10  REM SATELLITE PATH LOSS CALCULATIONS
20  PRINT CHR$(26)
30  PRINT "      *********************************************
40  PRINT "      *                                           *
50  PRINT "      *  BY DR. ALLEN KATZ, CHAIRMAN              *
60  PRINT "      *  DEPT ELECTRONICS ENGINEERING TECHNOLOGY  *
70  PRINT "      *  TRENTON STATE COLLEGE, CN550             *
80  PRINT "      *  TRENTON, NEW JERSEY 8625                 *
90  PRINT "      *                                           *
100  PRINT "      *  THE AUTHOR RESERVES RIGHTS TO THIS       *
110  PRINT "      *  PROGRAM; HOWEVER, COPYING AND USE FOR    *
120  PRINT "      *  EDUCATIONAL PURPOSES IS ENCOURAGED.      *
130  PRINT "      *                                           *
140  PRINT "      *  PLEASE REPORTS ANY ERRORS OR PROBLEMS    *
150  PRINT "      *  WITH THIS PROGRAM TO THE AUTHOR.         *
160  PRINT "      *  TEL (609) 771 2487                       *
170  PRINT "      *                                           *
180  PRINT "      *********************************************
190  PRINT
200  PRINT "SATELLITE SYSTEM DESIGN PROGRAM V1.2M 2/1/86": PRINT: PI=4*ATN(1)
210  DEF FNA(X,Y)=2*SQR(10^(((10/LOG(10))*LOG((0.55*4*PI^2)/Y^2)-X)/(-10)))
220  DEF FNG(A,B)=(10/LOG(10))*LOG(0.55*4*(PI^2)*((A/2)^2)/(B^2))
230  INPUT "UP LINK TRANSMITTER POWER IN WATTS "; W1: BK=0
240  P1=(10/LOG(10))*LOG(W1*1000): PRINT "POWER IN DBM ="; P1
250  INPUT "UP LINK FREQUENCY IN MHZ "; F1
260  L1=983.311/F1: PRINT "WAVELENGTH IN FEET ="; L1
270  INPUT "DISTANCE TO SATELLITE IN MILES "; D
280  LU=-(10/LOG(10))*LOG(4560*F1^2*D^2): PRINT "PATH LOSS IN DB ="; LU
290  INPUT "DO YOU WISH TO SPECIFY ANT IN TERMS OF 'SIZE' OR 'GAIN'"; Q$
300  IF Q$ = "SIZE" THEN 340 ELSE IF Q$ = "GAIN" THEN 320
310  PRINT "? TYPE EITHER 'SIZE' OR 'GAIN'": GOTO 290
320  INPUT "ANTENNA GAIN IN DB(ISO) ="; G1
330  D1=FNA(G1,L1): PRINT "EQUIVALENT DISH DIA IN FT ="; D1: GOTO 360
340  INPUT "EQUIV DISH DIA IN FT "; D1
350  G1=FNG(D1,L1): PRINT "GAIN IN DB(ISO) ="; G1
360  INPUT "GAIN OF SATELLITE RECEIVING ANT IN DB(ISO) "; GR
370  SI=P1+G1+LU+GR: PRINT "SIGNAL AT SAT RECEIVER IN DBM ="; SI
380  INPUT "SAT RECEIVER NF IN DB "; NS: NS=10^(NS/10): TS=293*(NS-1)
390  INPUT "SAT ANT TEMPERATURE ="; TT: TS=TS+TT
400  INPUT "SYSTEM BANDWIDTH IN HZ ="; BW: N1=(10/LOG(10))*LOG(BK*TS*BW)
410  SN=SI-N1: PRINT "INPUT SNR IN DB ="; SN: PRINT:
420  INPUT "DO YOU WANT TO CALC DOWN LINK (Y/N) "; Q$
430  IF Q$="N" THEN END
440  PRINT: PRINT "DOWN LINK CALCULATION": PRINT:
450  INPUT "SATELLITE OUTPUT POWER IN WATTS ="; W2
460  P2=(10/LOG(10))*LOG(W2*1000): PRINT "POWER OUT IN DBM ="; P2
470  SG=P2-SI: PRINT "REQUIRED SAT REPEATER GAIN IN DB ="; SG
480  INPUT "DOWN LINK FREQUENCY IN MHZ ="; F2
490  L2=983.311/F2: PRINT "DOWNLINK WAVELENGTH IN FT ="; L2
500  INPUT "IS DOWN LINK DISTANCE THE SAME (Y/N)"; Q$
510  IF Q$="N" THEN INPUT "NEW DISTANCE IN MILES ="; D
520  LD=-(10/LOG(10))*LOG(4560*F2^2*D^2): PRINT "DOWNLINK PATH LOSS IN DB="; LD
530  INPUT "DOWNLINK SAT ANTENNA GAIN IN DB(ISO) ="; GD
540  INPUT "DO YOU WISH TO SPECIFY RECEIVING ANT IN TERMS OF 'SIZE' OR 'GAIN'"; Q$
550  IF Q$ = "SIZE" THEN 600 ELSE IF Q$ = "GAIN" THEN 570
560  PRINT "? TYPE EITHER 'SIZE' OR 'GAIN'": GOTO 540
570  INPUT "RECEIVER ANTENNA GAIN IN DB(ISO) ="; G2
580  IF G2=0 THEN G2=9.9999E-05
590  D2=FNA(G2,L2): PRINT "EQUIVALENT DISH DIA IN FT ="; D2: GOTO 630
600  INPUT "EQUIV DISH DIA IN FT "; D2
610  G2=FNG(D2,L2): PRINT "GAIN IN DB(ISO) ="; G2
620  SI=P2+G2+LD+GD: PRINT "SIGNAL AT RECEIVER IN DBM ="; SI
630  INPUT "RECEIVER NF IN DB "; NS: NS=10^(NS/10): TS=293*(NS-1)
640  INPUT "RECEIVER ANT TEMPERATURE ="; TT: TS=TS+TT
650  NS=10^(N1/10): N2=(10/LOG(10))*LOG(BK*TS*BW+NS)
660  SN=SI-N2: PRINT "RECEIVER SNR IN DB ="; SN: END
