10  COLOR 0,7,1:CLS:LOCATE 2,70:COLOR 4,0:PRINT FRE(""):COLOR 0,7:WIDTH 80
20  DIM XD1(8),XD2(8),XD3(8),XD4(8),XD5(8)
30  READ XC1,XC2,XC3
40  FOR ZX=1 TO 8:READ XD1(ZX),XD2(ZX),XD3(ZX),XD4(ZX),XD5(ZX):NEXT ZX
50  OPEN "O",#1,"TEST.CAP":PRINT #1,XC1,XC2,XC3
60  FOR ZX=1 TO 8:PRINT #1,XD1(ZX),XD2(ZX),XD3(ZX),XD4(ZX),XD5(ZX):NEXT ZX
70  CLOSE #1
80  PRINT:PRINT" TSC ELECTRICAL CIRCUIT ANALYSIS PROGRAM V4.0 5/10/87"
90  PRINT "      *********************************************
100  PRINT "      *                                           *
110  PRINT "      *  BY DR. ALLEN KATZ, CHAIRMAN              *
120  PRINT "      *  DEPT ELECTRONICS ENGINEERING TECHNOLOGY  *
130  PRINT "      *  TRENTON STATE COLLEGE, CN4700            *
140  PRINT "      *  TRENTON, NEW JERSEY 08650-4700           *
150  PRINT "      *                                           *
160  PRINT "      *  THE AUTHOR RESERVES RIGHTS TO THIS       *
170  PRINT "      *  PROGRAM; HOWEVER, COPYING AND USE FOR    *
180  PRINT "      *  EDUCATIONAL PURPOSES IS ENCOURAGED.      *
190  PRINT "      *                                           *
200  PRINT "      *  PLEASE REPORT ANY ERRORS OR PROBLEMS     *
210  PRINT "      *  WITH THIS PROGRAM TO THE AUTHOR.         *
220  PRINT "      *  TEL (609) 771 2487                       *
230  PRINT "      *                                           *
240  PRINT "      *********************************************
250  PRINT " ALL UNITS IN VOLTS, AMPS, OHMS, FARADS, HENRIES, HZ, ETC."
260  PRINT " NODE VOLTAGES AND IMPEDANCES REFERENCED TO NODE 0 (ground)."
270  PRINT " ALL CALC ASSUMED AT DC (0 FREQ) UNLESS FREQ SET WITH 'F' OPTION."
280  PRINT " MAXIMUM NUMBER OF SWEEP POINTS=100. IF ERROR 'GOTO 1290'.
290  PRINT: INPUT " WANT ADDITIONAL INFORMATION (Y/N)"; B$: IF B$<>"Y" GOTO 1300
300  CLS: PRINT " TCAP IS A PROGRAM FOR THE ANALYSIS OF ELECTRICAL CIRCUITS CONSISTING"
310  PRINT " OF RESISTORS, CAPACITORS, INDUCTORS AND SEVERAL COMMON ACTIVE DEVICES.
320  PRINT " FIRST DRAW THE CIRCUIT TO BE ANALAYZED ON A SHEET OF PAPER. ASSIGN A
330  PRINT " NUMBER TO EACH ELEMENT OF THE CIRCUIT. THIS IS THE COMPONENT NUMBER.
340  PRINT " NEXT ASSIGN A NUMBER TO EACH NETWORK NODE. A NODE IS PRESENT AT THE
350  PRINT " CONNECTION BETWEEN ELEMENTS. NO TWO ELEMENTS MAY BE CONNECTED WITHOUT
360  PRINT " A NODE BETWEEN THEM. EVERY ELEMENT MUST BEGIN AND END AT A NODE. ANY
370  PRINT " NUMBER OF ELEMENTS MAY BE CONNECTED TO A COMMON NODE.": PRINT:
380  PRINT " ONCE ALL THE ELEMENTS AND NODES ARE NUMBERED, YOU ARE READY TO ENTER
390  PRINT " YOUR NETWORK INTO TCAP.": PRINT
400  PRINT " TCAP WILL FIRST ASK WHETHER YOU WISH TO READ A FILE. TCAP ALLOWS YOU
410  PRINT " TO SAVE ON DISK CIRCUIT FILES ('S') YOU HAVE PREVIOUSLY WORKED ON. IF
420  PRINT " YOU DO NOT HAVE A PREVIOUS FILE YOU WISH TO WORK ON, TYPE 'N' OR
430  PRINT " HIT CARRIAGE RETURN AND TCAP WILL PUT YOU IN THE NEW FILE MODE. IN
440  PRINT " THE NEW FILE MODE, TCAP WILL FIRST ASK FOR THE HIGHEST NODE NUMBER."
450  PRINT " NEXT TCAP WILL ASK FOR THE NUMBER OF VOLTAGE SOURCES. IT WILL THEN
460  PRINT " ASK FOR THE NUMBER OF COMPONENTS. THIS NUMBER INCLUDES THE VOLTAGE
470  PRINT " SOURCES. YOU ARE THEN READY TO ENTER THE CIRCUIT ELEMENTS. THEY MAY
480  PRINT " BE ENTERED IN ANY ORDER. ENTER NODE AND ELEMENT VALUES SEPARATED BY
490  PRINT " COMMAS AS DIRECTED BY TCAP. FOR EXAMPLE A RESISTOR (COMPONENT TYPE 'R')
500  PRINT " BETWEEN NODES 2 AND 3 OF 120 OHMS WOULD BE ENTERED AS '2,3,120'.
510  INPUT " PRESS <CR> TO CONTINUE"; Q$: PRINT
520  PRINT " SAMPLE FILES: SAMPLE-1 AND SAMPLE-2 ARE NORMALLY INCLUDED WITH TCAP
530  PRINT " TO ILLUSTRATE HOW FILES ARE CREATED. LOAD AND LIST THESE FILES WITH
540  PRINT " WITH THE 'L' FUNCTION BEFORE ATTEMPTING TO ENTER A CIRCUIT OF YOUR OWN.": PRINT
550  PRINT " TCAP INITIALLY ASSUMES CALCULATIONS ARE TO BE AT DC (0 Hz). FOR CALCULATIONS
560  PRINT " AT OTHER FREQUENCIES, THE FREQUENCY MUST BE SET WITH THE 'F' COMMAND.
570  PRINT " TCAP CAN PERFORM NODE VOLTAGE CALCULATIONS AT A SINGLE FREQUENCY OR OVER
580  PRINT " A RANGE OF FREQUENCIES (SWEEP). WHEN PERFORMING A NON-SWEEP CALCULATION,
590  PRINT " IT WILL ALWAYS RETURN TO THE LAST SINGLE FREQUENCY SPECIFIED. TCAP CAN
600  PRINT " ALSO CALCULATE OVER A 'SWEEP' OF COMPONENT VALUES WITH THE 'C' FUNCTION.
610  PRINT " AFTER A COMPONENT SWEEP CALCULATION, TCAP WILL RETURN TO THE ORIGINAL
620  PRINT " COMPONENT VALUE. TCAP ALWAYS TABULATES THE RESULTS OF A SWEEP CALCULATION,
630  PRINT " BUT IT CAN ALSO DISPLAY THESE RESULTS IN GRAPHICAL FORM.
640  PRINT: INPUT " DO YOU WANT ADDITIONAL INFORMATION ON FUNCTIONS (Y/N)"; Q$
650  IF Q$<>"Y" THEN 860 ELSE PRINT
660  PRINT " TCAP CALCULATES NODE VOLTAGES WITH THE 'V' FUNCTION. THE 'I' FUNCTION
670  PRINT " CALCULATES THE CURRENT SUPPLIED BY ALL NETWORK VOLTAGE AND CURRENT SOURCES,
680  PRINT " BUT DOES NOT CALCULATE THE CURRENT THROUGH INDIVIDUAL NETWORK ELEMENTS.
690  PRINT " TO DETERMINE THE VOLTAGE ACROSS AND THE CURRENT THROUGH AN ELEMENT
700  PRINT " (OR NETWORK BRANCH), THE 'B' COMMAND IS USED. THIS FUNCTION WILL PROVIDE
710  PRINT " THE VOLTAGES ACROSS ALL 2-TERMINAL NETWORK ELEMENTS AND THE CURRENTS
720  PRINT " THROUGH THESE ELEMENTS (EXCEPT FOR SOURCES - PROVIDED BY THE 'I' COMMAND).
730  PRINT " VOLTAGE IS DEFINED AS POSITIVE AT THE FIRST NODE RELATIVE TO THE SECOND
740  PRINT " NODE. THE 'Z' FUNCTION PROVIDES THE IMPEDANCE BETWEEN A SPECIFIED NODE AND
750  PRINT " GROUND (NODE 0) WITH ALL VOLTAGE SOURCES SHORTED AND ALL CURRENT SOURCES
760  PRINT " OPEN CIRCUITED. TO CALCULATE THE INPUT (OR OUTPUT) IMPEDANCE OF A
770  PRINT " NETWORK, DRIVE THE NETWORK WITH A 1 AMP CURRENT SOURCE. THE VOLTAGE
780  PRINT " AT THE NODE OF THE CURRENT SOURCE EQUALS THE DESIRED IMPEDANCE. THIS
790  PRINT " IMPEDANCE MAY BE PLOTTED USING THE 'F' COMMAND AND SWEEP FUNCTION.": PRINT
800  PRINT " UPTO TEN COMPONENTS (EXCLUDING VOLTAGE SOURCES) MAY BE ADDED TO
810  PRINT " A NETWORK WITH THE 'A' FUNCTION JUST AS LONG AS NO ADDITIONAL NODES
820  PRINT " ARE ADDED. 'R' AND 'D' ALLOW THE SUBSTITUTION AND DELETION OF COMPONENTS.": PRINT
830  PRINT " THE 'M' FUNCTION CAUSES TCAP TO DISPLAY THE MAGNITUDES OF VOLTAGES IN
840  PRINT " dB. A REFERENCE VOLTAGE MUST BE SUPPLIED FOR THE 20 LOG(V/VREF) CALC.
850  PRINT " THE M FUNCTION IS TURNED OFF BY ENTERING A VREF=0.
860  PRINT: INPUT " DO YOU WANT INFORMATION ON ACTIVE DEVICES (Y/N)"; Q$
870  IF Q$<>"Y" THEN 1300
880  CLS: PRINT " TCAP HAS 5 ACTIVE DEVICE MODELS: PNP, NPN AND FET TRANSISTORS, A
890  PRINT " CONTROLLED VOLTAGE SOURCE (WHICH CAN BE MADE TO ACT LIKE A TUBE) AND
900  PRINT " AN OPERATIONAL AMPLIFIER.
910  PRINT
920  PRINT " FOR AC PROBLEMS THE PNP AND NPN MODELS ARE IDENTICAL. THEY CONSIST
930  PRINT " OF A .1 OHM RESISTANCE (APPROXIMATE SHORT CIRCUIT) CONNECTED
940  PRINT " BETWEEN THE BASE AND EMITTER TERMINALS AND A CONTROLLED CURRENT
950  PRINT " SOURCE BETWEEN THE COLLECTOR AND EMITTER TERMINALS. THE CURRENT
960  PRINT " PRODUCED BY THIS CURRENT SOURCE IS THE PRODUCT OF THE CURRENT
970  PRINT " FLOWING INTO THE BASE TERMINAL TIMES BETA. MORE COMPLEX TRANSISTOR
980  PRINT " MODELS MAY BE CREATED BY ADDING EXTRA ELEMENTS IN SERIES AND PARALLEL
990  PRINT " WITH THE DEVICE TERMINALS. FOR EXAMPLE A RESISTOR CAN BE PUT IN SERIES
1000  PRINT " WITH THE BASE TERMINAL TO SIMULATE THE EFFECT OF Rie, OR IN PARALLEL
1010  PRINT " WITH THE COLLECTOR/EMITTER TERMINALS TO SIMULATE THE EFFECT OF Hoe.
1020  PRINT " ACTIVE DEVICES CAN ALSO BE COMBINED TO MAKE EVEN MORE COMPLEX MODELS.
1030  PRINT: PRINT " IN THE DC CASE (F=0), A .7 VOLT SOURCE IS ADDED IN SERIES WITH THE
1040  PRINT " BASE TERMINALS OF THE BIPOLAR TRANSISTOR MODELS, WITH THE APPROPRIATE
1050  PRINT " POLARITY FOR EITHER PNP OR NPN DEVICES, AND TCAP CHECKS FOR CORRECT
1060  PRINT " BIAS POLARITY. IN THE AC CASE (F>0), THE .7 VOLT BATTERY IS ELIMINATED
1070  PRINT " AND ALL CIRCUIT VOLTAGE SOURCES ARE SET TO THE FREQUENCY SPECIFIED BY
1080  PRINT " 'F', I.E., SEPARATE CIRCUITS ARE NEEDED FOR BIAS (DC) AND AC CONDITIONS.
1090  PRINT: INPUT " PRESS <CR> TO CONTINUE"; Q$: PRINT
1100  PRINT " THE OPERATIONAL AMPLIFIER IS A CONTROLLED VOLTAGE SOURCE WHOSE
1110  PRINT " OUTPUT VOLTAGE IS THE PRODUCT OF THE VOLTAGE BETWEEN ITS (+) AND
1120  PRINT " (-) TERMINALS TIMES GAIN. AN OPEN CIRCUIT (2 MEGOHMS) IS PRESENT BE-
1130  PRINT " TWEEN THE (+) AND (-) TERMINALS WHICH ARE FLOATING RELATIVE TO THE
1140  PRINT " OUTPUT. THE OUTPUT VOLTAGE SOURCE HAS EFFECTIVELY A ZERO IMPEDANCE AND
1150  PRINT " IS CONNECTED TO GROUND (NODE 0).
1160  PRINT
1170  PRINT " THE FET MODEL IS A CONTROLLED CURRENT SOURCE, WHOSE OUTPUT DEPENDS
1180  PRINT " ON THE VOLTAGE AT THE GATE TERMINAL TIMES MU. IT HAS BOTH NEAR
1190  PRINT " INFINITE INPUT AND OUTPUT IMPEDANCES. BOTH INPUT AND OUTPUT TERMINALS
1200  PRINT " ARE REFERENCED TO THE SOURCE NODE. DC WISE, THE FET MODEL CAN BE
1210  PRINT " CONSIDERED AN ENHANCEMENT TYPE FET, BUT NO CHECK IS MADE FOR
1220  PRINT " CORRECT (LINEAR) BIAS CONDITIONS.
1230  PRINT
1240  PRINT " THE CVS (CONTROLLED VOLTAGE SOURCE) IS SIMILAR TO THE OPERATIONAL
1250  PRINT " AMPLIFIER OR OP-AMP, BUT HAS BOTH INPUT AND OUTPUT VOLTAGE
1260  PRINT " REFERENCED TO ITS COMMON CATHODE NODE. IT HAS INFINITE INPUT
1270  PRINT " AND ZERO OUTPUT IMPEDANCES. TO MAKE THE CVS MODEL A VACUUM TUBE, A
1280  PRINT " LARGE RESISTOR SHOULD BE ADDED IN SERIES WITH THE PLATE NODE.
1290  PRINT: INPUT " WANT HARD COPY OF ABOVE INFORMATION (Y/N)"; Q$: IF Q$="Y" THEN GOSUB 5460
1300  IF QH=1 THEN QH=0: RETURN
1310  CLEAR: PI=3.14159: P2=PI*2: P6=PI/180
1320  CLS:COLOR 1,14:FILES "*.CAP":COLOR 0,7:LOCATE 2,70:COLOR 4,0:PRINT FRE(""):COLOR 0,7: LOCATE 10,2:PRINT:PRINT;TAB(10);"DO YOU WANT TO ENTER A FILE (Y/N)";:INPUT A$
1330  IF A$="Y" THEN 1790
1340  PRINT:PRINT;TAB(10);" WHAT IS THE HIGHEST NODE NUMBER";:INPUT LS
1350  IF LS<1 OR LS<>INT(LS) THEN 1340
1360  PRINT:INPUT " HOW MANY VOLTAGE SOURCES ARE IN THE CIRCUIT"; LV
1370  IF LV<0 OR LV<>INT(LV) THEN 1360 ELSE NO=LS+LV
1380  PRINT:INPUT " HOW MANY COMPONENTS ARE IN THE CIRCUIT"; CT
1390  IF CT<1 OR CT<>INT(CT) THEN 1380
1400  COLOR 4,0:LOCATE 2,70:PRINT FRE(""):DIM Y(NO,NO+1),X(NO,NO+1),T(CT+LV+5),N1(CT+LV+5),N2(CT+LV+5),V(CT+LV+5),G(CT+LV+5),FP(100),FR(100),FY(100),FF(100):COLOR 0,7
1410  FOR CR=1 TO CT: GOSUB 2390: NEXT: GOTO 1630
1420  PRINT: PRINT " A TCAP PROGRAM ERROR HAS OCCURED"
1430  REM******************** MENU ********************
1440  PRINT:GOTO 1630
1450  W=WB: PRINT: PRINT "Frequency= ";(W/P2)/1000;" KHz"
1460  COLOR 7,1:PRINT:PRINT;"YOUR SELECTION:":PRINT:PRINT;TAB(2);"[ A, B, C, D, END, F, H<ELP>, I, L, M, N, R, S, V, Z ]";:INPUT C$:COLOR 0,7
1470  IF C$="END" THEN COLOR 4,0,0:CLS:PRINT:PRINT;TAB(10);"END TCAP (T.S.C. CIRCUIT ANALYSIS PROGRAM)":COLOR 7,0,0:END
1480  C$=LEFT$(C$,2)
1490  IF C$="A" THEN CLS:GOSUB 2380
1500  IF C$="B" THEN CLS:GOSUB 4690
1510  IF C$="N" THEN CLS:GOTO 1300
1520  IF C$="S" THEN CLS:GOSUB 1870
1530  IF C$="F" THEN CLS:GOSUB 1930
1540  IF C$="I" THEN CLS:GOSUB 4620
1550  IF C$="L" THEN CLS:GOSUB 4420
1560  IF C$="V" THEN CLS:GOSUB 2850
1570  IF C$="D" THEN CLS:GOSUB 3510
1580  IF C$="Z" THEN CLS:GOSUB 3620
1590  IF C$="R" THEN CLS:GOSUB 2360
1600  IF C$="C" THEN CLS:GOSUB 3690
1610  IF C$="M" THEN CLS:GOSUB 3550
1620  IF LEFT$(C$,1)="H" THEN CLS: QH=1: GOSUB 250
1630  COLOR 14,1:CLS:PRINT: PRINT;TAB(21);"OPTIONS MENU:":FOR X=10 TO 62:PRINT;TAB(X);CHR$(205);:NEXT X:PRINT
1640  COLOR 4,1:PRINT;TAB(10), "[A]";:COLOR 14,1:PRINT;" - ADD CIRCUIT COMPONTENT"
1650  COLOR 4,1:PRINT TAB(10), "[B]";:COLOR 14,1:PRINT;" - CALCULATE BRANCH VOLTAGES AND CURRENTS"
1660  COLOR 4,1:PRINT TAB(10), "[C]";:COLOR 14,1:PRINT;" - CHANGE AND SWEEP COMPONENT VALUE"
1670  COLOR 4,1:PRINT TAB(10), "[D]";:COLOR 14,1:PRINT;" - DELETE CIRCUIT COMPONENT"
1680  COLOR 4,1:PRINT TAB(10), "[F]";:COLOR 14,1:PRINT;" - SET OR SWEEP FREQUENCY"
1690  COLOR 4,1:PRINT TAB(10), "[I]";:COLOR 14,1:PRINT;" - CALCULATE SOURCE CURRENTS"
1700  COLOR 4,1:PRINT TAB(10), "[L]";:COLOR 14,1:PRINT;" - LIST PRESENT COMPONENTS"
1710  COLOR 4,1:PRINT TAB(10), "[M]";:COLOR 14,1:PRINT;" - VOLTAGE MAGNITUDE IN dB"
1720  COLOR 4,1:PRINT TAB(10), "[N]";:COLOR 14,1:PRINT;" - NEW CIRCUIT"
1730  COLOR 4,1:PRINT TAB(10), "[R]";:COLOR 14,1:PRINT;" - REPLACE CIRCUIT COMPONENT"
1740  COLOR 4,1:PRINT TAB(10), "[S]";:COLOR 14,1:PRINT;" - SAVE CIRCUIT FILE"
1750  COLOR 4,1:PRINT TAB(10), "[V]";:COLOR 14,1:PRINT;" - CALCULATE NODE VOLTAGES"
1760  COLOR 4,1:PRINT TAB(10), "[Z]";:COLOR 14,1:PRINT;" - CALCULATE NODE IMPEDANCE"
1770  COLOR 4,1:PRINT TAB(10), "[END]";:COLOR 14,1:PRINT;" - END SESSION": COLOR 0,7:GOTO 1450
1780  REM ************ FILE LOAD ******************
1790  CLEAR:PI=3.14159:P2=PI*2:P6=PI/180:PRINT:PRINT;TAB(5);"FILE NAME [No Extension], OR QUIT";:INPUT F$
1800  IF ( F$="QUIT")OR(F$="quit") THEN 1450
1810  F$=F$+".CAP": OPEN "I",#1,F$
1820  INPUT#1, CT, LS, LV: NO=LS+LV
1830  DIM Y(NO,NO+1),X(NO,NO+1),T(CT+LV+5),N1(CT+LV+5),N2(CT+LV+5),V(CT+LV+5),G(CT+LV+5),FP(100),FR(100),FY(100),FF(100)
1840  FOR P=1 TO CT: INPUT#1,T(P),N1(P),N2(P),V(P),G(P): NEXT
1850  CLOSE#1: GOTO 1430
1860  REM ************ FILE SAVE ******************
1870  PRINT: INPUT " FILE NAME"; F$: F$=F$+".CAP"
1880  OPEN "O",#1,F$
1890  PRINT#1, CT, LS, LV
1900  FOR P=1 TO CT: PRINT#1,T(P),N1(P),N2(P),V(P),G(P): NEXT
1910  CLOSE#1: RETURN
1920  REM ************* FREQ SWEEP MODULE *****************
1930  PRINT:PRINT;TAB(20);"Frequency Modes:":PRINT;TAB(6);"______________________________________________":PRINT
1940  PRINT;TAB(18);"1 - Single Frequency"
1950  PRINT;TAB(18);"2 - Linear Frequency Sweep"
1960  PRINT;TAB(18);"3 - Log Frequency Sweep"
1970  PRINT:INPUT "       Frequency Mode-->";LX
1980  IF LX<1 OR LX>3 THEN 1930
1990  IF LX>1 THEN 2020
2000  PRINT: INPUT " Desired Frequency-->"; W
2010  PRINT:PRINT:PRINT:PRINT" FREQUENCY SET TO "W" FOR ALL [B], [I], [V], [Z] AND [C] CALCULATIONS": W=P2*W: WB=W:FOR CC=1 TO 1279:NEXT CC:RETURN
2020  PRINT: W$="Frequency": E$="FREQ"
2030  PRINT:INPUT " F min, F max, # OF POINTS:";F1,F2,IN:IN=IN-1
2040  IF F1>=0 AND F2>=0 AND F2>=F1 THEN 2060
2050  PRINT"--- IMPROPER ENTRY ! ---": GOTO 2030
2060  PRINT "OUTPUT NODE..( 1 -"LS")  ";:INPUT ND
2070  IF ND>LS OR ND<1 THEN PRINT"NODES ARE FROM 1 TO"LS"ONLY.":GOTO 2040
2080  IF LX=2 THEN F3=F1: F4=F2: GOTO 2100
2090  F4=LOG(F2)/LOG(10):IF F1=0 THEN F3=0 ELSE F3=LOG(F1)/LOG(10)
2100  PRINT:PRINT;TAB(10);"Working...";:I=0:M=IN+1:II=(F4-F3)/IN: EP=0.01*II
2110  FOR P=0 TO IN+1: FP(P)=0: FR(P)=0: FY(P)=0: FF(P)=0: NEXT P
2120  FOR FX=F3 TO F4+EP STEP II: I=I+1: PRINT I;
2130  IF LX=3 THEN IF FX<>0 THEN W=P2*10^FX ELSE W=0
2140  IF LX=2 THEN W=P2*FX
2150  IF LX=3 AND FX<>0 THEN FF(I)=10^FX ELSE FF(I)=FX
2160  GOSUB 3910: GOSUB 3080
2170  FY(I)=Y(ND,0): FR(I)=X(ND,0): NEXT FX: W=0: PRINT CHR$(26)
2180  PRINT: PRINT" VOLTAGE - "W$" TABULATION" TAB(50)F$: PRINT
2190  PRINT;TAB(3);E$;TAB(14);"REAL";TAB(26);"IMAGINARY";TAB(39);"MAGNITUDE";R$;TAB(54);"PHASE ANGLE":CN=0:FOR Z=1 TO 79:PRINT;TAB(Z);CHR$(205);:NEXT Z:PRINT
2200  FOR I=1 TO M
2201  'IF FY(I)<1E-08 THEN FY(I)=0
2202  'IF FR(I)<1E-08 THEN FR(I)=0
2208  MG=SQR(FY(I)^2+FR(I)^2): IF RF>0 THEN MG=20*LOG(MG/RF+0)/LOG(10)
2209  IF MG<9E-09 THEN MG=0
2210  IF CN<>0 AND CN/20=INT(CN/20) THEN INPUT"PRESS <CR> TO CONTINUE"; A$
2220  CN=CN+1:IF FY(I)=0 THEN K=SGN(FR(I))*90 ELSE IF FY(I)>0 THEN K=1/P6*ATN(FR(I)/FY(I)) ELSE K=1/P6*ATN(FR(I)/FY(I))+180
2230  SF$="  Hz":FF(I)=INT(100*FF(I)+0.5)/100:IF FF(I)<999.99 THEN PRINT USING "####.##";FF(I);:PRINT;SF$;TAB(13);:GOTO 2270
2240  IF FF(I)<=999999 THEN SF$=" KHz":FF(I)=INT(FF(I)/10+0.5)/100:PRINT USING "####.##";FF(I);:PRINT;SF$;TAB(13);:GOTO 2270
2250  IF FF(I)<1E+09 THEN SF$=" MHz":FF(I)=INT(FF(I)/10000+0.5)/100:PRINT USING "####.##";FF(I);:PRINT;SF$;TAB(13);:GOTO 2270
2260  IF FF(I)>=1E+09 THEN SF$=" GHz":FF(I)=INT(FF(I)/1E+07+0.5)/100:PRINT USING "####.##";FF(I);:PRINT;SF$;TAB(13);:GOTO 2270
2270  PRINT USING "###.##^^^^   ";FY(I);FR(I);MG;: PRINT USING "   ###.##";K;:PRINT;CHR$(248)
2280  NEXT I: PRINT: INPUT " WANT HARD COPY (Y/N)"; Q$: IF Q$="Y" THEN GOSUB 6900
2290  PRINT: INPUT " WANT TO PLOT VOLTAGE (Y/N)";Q$ :IF Q$<>"Y" THEN 2310
2300  V$="V": IF RF>0 THEN NA$="VOLTAGE RATIO IN dB": GOTO 2330 ELSE NA$="VOLTAGE": GOTO 2330
2310  PRINT:INPUT" WANT TO PLOT PHASE ANGLE (Y/N)";Q$:IF Q$="Y" THEN NA$="ANGLE ":V$="P":GOTO 2330
2320  RETURN
2330  PRINT: INPUT " LINE WIDTH (TYP 80)"; LL: IF LL=0 THEN LL=80
2340  XX=LL: GOTO 5110
2350  REM *********** COMPONENT INPUT/ADD/REPLACE **************
2360  PRINT: INPUT " COMPONENT NUMBER";L
2370  IF L<=CT AND L>0 THEN ZN=L: GOTO 2410 ELSE PRINT"INVALID COMPONENT NUMBER. ENTRY IGNORED.":RETURN
2380  ZN=CT: CT=CT+1
2390  ZN=ZN+1: IF CR>1 THEN 2410
2400  CLS:ZZ=17:PRINT: PRINT "COMPONENT SELECTION SECTION"
2410  COLOR 4,7:PRINT: PRINT;TAB(ZZ);"[R]";:COLOR 0,7:PRINT;"ESISTOR"
2420  COLOR 4,7:PRINT;TAB(ZZ);"[I]";:COLOR 0,7:PRINT;" INDUCTOR"
2430  COLOR 4,7:PRINT;TAB(ZZ);"[C]";:COLOR 0,7:PRINT;" CAPACITOR"
2440  COLOR 4,7:PRINT;TAB(ZZ);"[CS]";:COLOR 0,7:PRINT;" CURRENT SOURCE"
2450  COLOR 4,7:PRINT;TAB(ZZ);"[VS]";:COLOR 0,7:PRINT;" VOLTAGE SOURCE"
2460  COLOR 4,7:PRINT;TAB(ZZ);"[NPN]";:COLOR 0,7:PRINT;" TRANSISTOR"
2470  COLOR 4,7:PRINT;TAB(ZZ);"[PNP]";:COLOR 0,7:PRINT;" TRANSISTOR"
2480  COLOR 4,7:PRINT;TAB(ZZ);"[FET]";:COLOR 0,7:PRINT;" FEILD EFFECT TRANSISTOR"
2490  COLOR 4,7:PRINT;TAB(ZZ);"[CVS]";:COLOR 0,7:PRINT;" CONT. VOLT. SOURCE (TUBE)"
2500  COLOR 4,7:PRINT;TAB(ZZ);"[OPAMP]";:COLOR 0,7:PRINT;" OPERATIONAL AMPLIFIER"
2501  COLOR 4,7:PRINT;TAB(ZZ);"[L]";:COLOR 0,7:PRINT;" LIST CIRCUIT COMPONENTS":PRINT
2510  INPUT "     TYPE OF CIRCUIT ELEMENT OR LIST ELEMENTS...."; TY$
2520  IF TY$="R" THEN TY=1
2521  IF TY$="L" THEN GOSUB 4420
2530  IF TY$="I" THEN TY=2
2540  IF TY$="C" THEN TY=3
2550  IF TY$="CS" THEN TY=4
2560  IF TY$="VS" THEN TY=5
2570  IF TY$="NPN" THEN TY=6
2580  IF TY$="PNP" THEN TY=7
2590  IF TY$="FET" THEN TY=8
2600  IF TY$="CVS" THEN TY=9
2610  IF TY$="OPAMP" THEN TY=10
2620  IF TY<1 OR TY>10 THEN 2410 ELSE 2680
2630  PRINT;TAB(2);:INPUT N1(ZN), N2(ZN), V(ZN)
2640  IF V(ZN)<0 THEN INPUT "ELEMENT VALUE MUST BE GREATER THAN 0, PROPER VALUE"; V(ZN)
2650  IF N1(ZN)<=LS AND N2(ZN)<=LS AND N1(ZN)>=0 AND N2(ZN)>=0 THEN RETURN
2660  PRINT "IMPROPER NODE VALUE. ENTRY IGNORED"
2670  T(ZN)=0:ZN=ZN-1:RETURN
2680  PRINT: PRINT "COMPONENT #"; ZN: PRINT
2690  T(ZN)=TY: ON TY GOTO 2700,2710,2720,2730,2760,2770,2770,2790,2800,2780
2700  PRINT"FROM NODE,  TO NODE,  RESISTANCE":GOTO 2630
2710  PRINT"FROM NODE,  TO NODE,  INDUCTANCE":GOTO 2630
2720  PRINT"FROM NODE,  TO NODE,  CAPACITANCE":GOTO 2630
2730  PRINT"(-) NODE,  (+) NODE,  CURRENT MAG.,  PHASE ANGLE"
2740  PRINT;TAB(3);:INPUT N1(ZN), N2(ZN), V(ZN), G(ZN)
2750  IF N1(ZN)<=LS AND N2(ZN)<=LS AND N1(ZN)>=0 AND N2(ZN)>=0 THEN RETURN ELSE 2660
2760  PRINT"(-) NODE,  (+) NODE,  VOLTAGE MAG.,  PHASE ANGLE":GOTO 2740
2770  PRINT"BASE NODE,  EMITTER NODE,  COLLECTOR NODE,  BETA":GOTO 2740
2780  PRINT"OUTPUT,  (-) INPUT,  (+) INPUT,  GAIN FACTOR":GOTO 2740
2790  PRINT"GATE NODE,  SOURCE NODE,  DRAIN NODE,  GM":GOTO 2740
2800  PRINT"GRID NODE,  CATHODE NODE,  PLATE NODE,  VOLTAGE GAIN":GOTO 2740
2810  REM *************** NODE VOLTAGE CALC ****************
2820  PRINT: PRINT" NODE? (0 -"LS")  ";: INPUT ND
2830  IF ND>LS THEN PRINT"THE HIGHEST NODE NUMBER IS "LS: GOTO 2820
2840  IF ND>=0 THEN 2870
2850  PRINT:PRINT"ENTER NUMBER FROM 0-";LS;"AN ENTRY OF 0 WILL PROVIDE SOLUTION AT ALL NODES"
2860  GOTO 2820
2870  PRINT: PRINT;TAB(10);" Working....": GOSUB 3910: GOSUB 3080
2880  PRINT: IF C$="I" THEN PRINT F$,"CURRENT" ELSE IF C$="Z" THEN PRINT F$, "IMPEDANCE" ELSE PRINT F$, "VOLTAGE"
2890  PRINT"Frequency="W/P2: PRINT
2900  IF C$="Z" THEN RK=RF: RF=0: GOSUB 3600
2910  PRINT"NODE"TAB(11)"REAL"TAB(21)"IMAGINARY"TAB(33)"MAGNITUDE"R$TAB(44)"PHASE ANGLE"
2920  IF C$="I" THEN RETURN
2930  IF ND=0 THEN 2950
2940  L=ND: GOTO 2960
2950  FOR L=1 TO LS
2960  MG=SQR(Y(L,0)^2+X(L,0)^2): IF RF>0 THEN MG=20*LOG(MG/RF+0)/LOG(10)
2970  IF Y(L,0)=0 THEN PA=90*SGN(X(L,0)) ELSE IF Y(L,0)>0 THEN PA=1/P6*ATN(X(L,0)/Y(L,0)) ELSE PA=1/P6*ATN(X(L,0)/Y(L,0))+180
2980  IF C$="I" THEN PRINT N1(LQ)"-"N2(LQ);:GOTO 3000
2990  PRINT L TAB(9);
3000  PRINT USING "##.##^^^^   "; Y(L,0); X(L,0); MG;: PRINT USING " ####.#"; PA
3010  IF L/20=INT(L/20)THEN PRINT: INPUT" PRESS <CR> TO CONTINUE";FR:PRINT
3020  IF ND<>0 THEN 3040
3030  NEXT L
3040  IF C$="I" THEN RETURN
3050  PRINT: INPUT " WANT HARD COPY (Y/N)"; Q$: IF Q$="Y" THEN GOSUB 6460
3060  IF C$="Z" THEN RF=RK: GOSUB 3600
3070  RETURN
3080  FOR L=1 TO NO: IF Y(L,L)^2+X(L,L)^2<>0 THEN 3110
3090  FOR LT=1 TO NO: IF Y(L,LT)^2+X(L,LT)^2<>0 OR Y(LT,L)^2+X(LT,L)^2<>0 THEN 3110
3100  NEXT LT: IF Y(L,NO+1)^2+X(L,NO+1)^2<>0 THEN 3110 ELSE Y(L,L)=1
3110  NEXT L: FOR L=1 TO NO
3120  DE=Y(L,L)^2+X(L,L)^2: IF DE>0 OR (L=NO AND DE<>0) THEN 3200
3130  IF L=NO THEN 3170
3140  FOR LT=L+1 TO NO: IF (Y(L,L)+Y(LT,L))^2+(X(L,L)+X(LT,L))^2<0 THEN 3160
3150  FOR LR=1 TO NO+1: Y(L,LR)=Y(L,LR)+Y(LT,LR): X(L,LR)=X(L,LR)+X(LT,LR): NEXT LR: GOTO 3120
3160  NEXT LT
3170  PRINT;" ONE OF THE FOLLOWING PROBLEMS EXIST:":PRINT;"   ___________________________________________"
3180  PRINT;" (1) IMPROPER CONNECTION AT ";:IF L>LS THEN PRINT"VOLTAGE SOURCE" ELSE PRINT"NODE"L
3190  PRINT;" (2) CIRCUIT WILL NOT OPERATE AT A FREQUENCY OF"W/P2" RECHECK CIRCUIT CONNECTIONS USING THE 'L' COMMAND.":PRINT:RETURN
3200  DR=Y(L,L)/DE:DI=-X(L,L)/DE
3210  FOR J=1 TO NO
3220  IF J=L THEN 3300
3230  IF ND=0 THEN 3250
3240  IF J>=L THEN 3250 ELSE IF J<>ND THEN 3300
3250  IF Y(J,L)=0 AND X(J,L)=0 THEN 3300
3260  FR=Y(J,L)*DR-X(J,L)*DI:FI=X(J,L)*DR+Y(J,L)*DI
3270  FOR P=L+1 TO NO+1
3280  TR=Y(L,P)*FR-X(L,P)*FI:TI=X(L,P)*FR+Y(L,P)*FI
3290  Y(J,P)=Y(J,P)-TR:X(J,P)=X(J,P)-TI: NEXT P
3300  NEXT J: NEXT L
3310  FOR L=1 TO NO:DF=Y(L,L)^2+X(L,L)^2:Y(L,0)=(Y(L,NO+1)*Y(L,L)+X(L,NO+1)*X(L,L))/DF
3320  X(L,0)=(X(L,NO+1)*Y(L,L)-Y(L,NO+1)*X(L,L))/DF:NEXT L
3330  IF W<>0 THEN RETURN
3340  FOR RL=1 TO CT:IF T(RL)>5 AND T(RL)<11 THEN 3360
3350  NEXT RL: RETURN
3360  Y(0,0)=0:X(0,0)=0
3370  DP=SGN(Y(N1(RL),0))*SQR(Y(N1(RL),0)^2+X(N1(RL),0)^2)
3380  DM=SGN(Y(N2(RL),0))*SQR(Y(N2(RL),0)^2+X(N2(RL),0)^2)
3390  SP=SGN(Y(V(RL),0))*SQR(Y(V(RL),0)^2+X(V(RL),0)^2)
3400  DP=INT(1000*DP)/1000:DM=INT(1000*DM)/1000:SP=INT(1000*SP)/1000
3410  ON T(RL)-5 GOTO 3430,3470
3420  GOTO 3350
3430  IF DP>=DM+0.7 THEN 3450
3440  PRINT" BASE-EMITTER JUNCTION OF TRANSISTOR AT B="N1(RL)"E="N2(RL)"C="V(RL):GOTO 3490
3450  IF SP>=DP THEN 3350
3460  PRINT" BASE-COLLECTOR JUNCTION OF TRANSISTOR AT B="N1(RL)"E="N2(RL)"C="V(RL):GOTO 3490
3470  IF DM-0.7<DP THEN 3440
3480  IF SP>DP THEN 3460 ELSE 3350
3490  PRINT" IS REVERSE BIASED.  LINEAR CIRCUIT ANALYSIS IS NOT POSSIBLE.":RETURN
3500  REM *************** REMOVE ELEMENT *******************
3510  GOSUB 4420:PRINT:COLOR 4,15:PRINT;"   CAUTION!  A CIRCUIT ELEMENT WILL BE REMOVED BY THE FOLLOWING ACTION..":COLOR 0,15:PRINT;TAB(20);"ENTER 999 TO ABORT ":PRINT: INPUT "BRANCH # ";L
3519  IF L=999 GOTO 1430
3520  IF L<=CT AND L>0 THEN 3530 ELSE PRINT"INVALID COMPONENT NUMBER. ENTRY IGNORED.":RETURN
3530  IF L=CT THEN 3540 ELSE FOR P=L TO CT-1:T(P)=T(P+1):N1(P)=N1(P+1):N2(P)=N2(P+1):V(P)=V(P+1):G(P)=G(P+1):NEXT:CT=CT-1:RETURN
3540  T(CT)=0:CT=CT-1:RETURN
3550  REM ************** MAG IN dB SET **********************
3560  PRINT: PRINT "ALL VOLTAGE MAGNITUDES WILL BE IN dB RELATIVE TO REFERENCE."
3570  PRINT "TO RESET TO NORMAL MODE ENTER ZERO OR CARRIAGE RETURN."
3580  INPUT "REFERENCE VOLTAGE FOR dB CALC"; RF
3590  IF RF<0 THEN PRINT: PRINT "dB REF MUST BE > 0!": GOTO 3580
3600  R$=" dB": IF RF=0 THEN R$="": RETURN ELSE RETURN
3610  REM ************** Z CALC *****************************
3620  PRINT: PRINT"IMPEDANCE AT WHICH NODE?  ( 1 -"LS")  ";:INPUT ND: IF ND<1 OR ND>LS THEN 3620
3630  PRINT: PRINT;TAB(10);" Working...": PRINT:FOR L=1 TO NO:FOR CR=1 TO NO+1:Y(L,CR)=0:X(L,CR)=0:NEXT CR:NEXT L
3640  CR=CT:FOR CT=1 TO CR
3650  IF T(CT)=5 THEN Y=1E+10:GOSUB 4000
3660  IF T(CT)<>5 THEN GOSUB 3940
3670  NEXT CT:CT=CR:FOR L=1 TO NO:IF L=ND THEN Y(L,NO+1)=1 ELSE Y(L,NO+1)=0
3680  X(L,NO+1)=0:NEXT L:GOSUB 3080: GOTO 2880
3690  REM ************* CHANGE COMPONENT VALUES ***************
3700  PRINT: PRINT "VARIABLE COMPONENT MODE"
3710  W$="COMPONENT VALUE": E$="VALUE"
3720  PRINT "FREQUENCY SHOULD BE PRE-SET WITH <F> MODE <1>"
3730  PRINT: INPUT "   BRANCH # TO BE VARIED"; ZN
3740  IF ZN>CT OR ZN<1 THEN PRINT "POINT OUT OF RANGE": RETURN
3750  INPUT "MIN VALUE, MAX VALUE AND # OF POINTS"; C1,C2,IN
3760  IF C1>=0 AND C2>=0 AND C2>C1 THEN 3780
3770  PRINT "IMPROPER ENTRY": GOTO 3750
3780  PRINT "WHICH NODE? ( 1 -"LS")  ";:INPUT ND
3790  IF ND>LS OR ND<1 THEN PRINT"NODES ARE FROM 1 TO"LS"ONLY.":GOTO 3610
3800  PRINT: PRINT;TAB(10);"Working...";: I=0: M=IN+1: EP=0.01*(C2-C1)/IN
3810  FOR P=0 TO IN+1: FP(P)=0: FR(P)=0: FY(P)=0: FF(P)=0: NEXT P
3820  IF T(ZN)<6 THEN TV=V(ZN) ELSE TV=G(ZN)
3830  FOR CX=C1 TO C2+EP STEP (C2-C1)/IN: I=I+1: PRINT I;
3840  IF T(ZN)<6 THEN V(ZN)=CX ELSE G(ZN)=CX
3850  FF(I)=CX: GOSUB 3910: GOSUB 3080
3860  FY(I)=Y(ND,0): FR(I)=X(ND,0): NEXT CX
3870  IF T(ZN)<6 THEN V(ZN)=TV ELSE G(ZN)=TV
3880  GOTO 2180
3890  REM <BACK TO FREQ SWEEP TAB MODULE> ****
3900  REM ********************* MAT **********************
3910  FOR L=1 TO NO:FOR P=1 TO NO+1:Y(L,P)=0:X(L,P)=0:NEXT P:NEXT L
3920  LP=1:CR=CT:FOR CT=1 TO CR:GOSUB 3940
3930  NEXT CT: CT=CR: RETURN
3940  ON T(CT) GOTO 3950,3970,3990,4110,4160,4190,4200,4380,4390,4350
3950  IF V(CT)=0 THEN Y=1000 ELSE Y=1/V(CT)
3960  X=0:GOTO 4000
3970  IF W<>0 THEN X=-1/(W*V(CT)) ELSE X=1E+10
3980  Y=0:GOTO 4000
3990  Y=0:X=W*V(CT)
4000  IF X^2+Y^2<0 AND X^2+Y^2<>0 THEN PRINT "ADMITTANCE UNDERFLOW. COMPONENT NUMBER";CT: GOTO 1450
4010  IF Y=0 THEN 4060
4020  Y(N1(CT),N1(CT))=Y(N1(CT),N1(CT))+Y
4030  Y(N1(CT),N2(CT))=Y(N1(CT),N2(CT))-Y
4040  Y(N2(CT),N1(CT))=Y(N2(CT),N1(CT))-Y
4050  Y(N2(CT),N2(CT))=Y(N2(CT),N2(CT))+Y
4060  IF X=0 THEN RETURN
4070  X(N1(CT),N1(CT))=X(N1(CT),N1(CT))+X
4080  X(N1(CT),N2(CT))=X(N1(CT),N2(CT))-X
4090  X(N2(CT),N1(CT))=X(N2(CT),N1(CT))-X
4100  X(N2(CT),N2(CT))=X(N2(CT),N2(CT))+X:RETURN
4110  Y=V(CT)*COS(P6*G(CT)):X=V(CT)*SIN(P6*G(CT))
4120  Y(N1(CT),NO+1)=Y(N1(CT),NO+1)-Y
4130  X(N1(CT),NO+1)=X(N1(CT),NO+1)-X
4140  Y(N2(CT),NO+1)=Y(N2(CT),NO+1)+Y
4150  X(N2(CT),NO+1)=X(N2(CT),NO+1)+X:RETURN
4160  Y(N1(CT),LS+LP)=Y(N1(CT),LS+LP)+1:Y(N2(CT),LS+LP)=Y(N2(CT),LS+LP)-1
4170  Y(LS+LP,N1(CT))=Y(LS+LP,N1(CT))-1:Y(LS+LP,N2(CT))=Y(LS+LP,N2(CT))+1
4180  Y(LS+LP,NO+1)=Y(LS+LP,NO+1)+V(CT)*COS(P6*G(CT)):X(LS+LP,NO+1)=X(LS+LP,NO+1)+V(CT)*SIN(P6*G(CT)):LP=LP+1:RETURN
4190  DP=N1(CT):SP=V(CT):DM=N2(CT):SM=N2(CT):GOTO 4210
4200  DP=N2(CT):SP=N2(CT):DM=N1(CT):SM=V(CT)
4210  Y(SP,DP)=Y(SP,DP)+G(CT)*10
4220  Y(SP,DM)=Y(SP,DM)-G(CT)*10
4230  Y(SM,DM)=Y(SM,DM)+G(CT)*10
4240  Y(SM,DP)=Y(SM,DP)-G(CT)*10
4250  IF W<>0 THEN 4300
4260  Y(SP,NO+1)=Y(SP,NO+1)+7*G(CT)
4270  Y(SM,NO+1)=Y(SM,NO+1)-7*G(CT)
4280  Y(DP,NO+1)=Y(DP,NO+1)+7
4290  Y(DM,NO+1)=Y(DM,NO+1)-7
4300  Y=10: X=0: GOTO 4020
4310  Y(SP,DM)=Y(SP,DM)-G(CT)
4320  Y(SP,DP)=Y(SP,DP)+G(CT)
4330  Y(SM,DP)=Y(SM,DP)-G(CT)
4340  Y(SM,DM)=Y(SM,DM)+G(CT):RETURN
4350  Y=1E+10:X=0:NN=N2(CT):N2(CT)=0:GOSUB 4020:N2(CT)=NN:NN=N1(CT):N1(CT)=V(CT):Y=4.99E-07:GOSUB 4020:N1(CT)=NN
4360  G(CT)=G(CT)*1E+10:DP=N2(CT):SP=N1(CT):DM=V(CT):SM=0:GOSUB 4310
4370  G(CT)=G(CT)*0:RETURN
4380  DP=N1(CT):SP=V(CT):DM=N2(CT):SM=N2(CT):GOTO 4310
4390  DP=N1(CT):SP=V(CT):DM=N2(CT):SM=N2(CT): G(CT)=G(CT)*1E+10: GOSUB 4310
4400  G(CT)=G(CT)*0: Y=1E+10: X=0: NN=N1(CT): N1(CT)=V(CT): GOSUB 4020: N1(CT)=NN: RETURN
4410  REM **************** LIST CIRCUIT *******************
4420  PRINT:PRINT F$,"FREQUENCY="W/P2:PRINT
4430  PRINT"BRANCH"TAB(12)"NODE":PRINT;" # ";TAB(10);"CONNECTION:"TAB(27)"TYPE:"TAB(39)"VALUE:"TAB(53)"PHASE ANGLE:":FOR X=1 TO 70:PRINT;TAB(X);CHR$(205);:NEXT X:PRINT
4440  FOR L=1 TO CT:PRINT L;TAB(7);
4450  ON T(L) GOTO 4500,4510,4520,4530,4540,4560,4570,4590,4600,4580
4460  IF L/20=INT(L/20) THEN INPUT"PRESS <CR> TO CONTINUE";ZZ
4470  NEXT L
4480  PRINT: INPUT "WANT HARD COPY (Y/N)"; Q$: IF Q$="Y" THEN GOSUB 6610
4490  RETURN
4500  PRINT N1(L)"-"N2(L)TAB(27)"RESISTOR"TAB(39)V(L):GOTO 4460
4510  PRINT N1(L)"-"N2(L)TAB(27)"INDUCTOR"TAB(39)V(L):GOTO 4460
4520  PRINT N1(L)"-"N2(L)TAB(27)"CAPACITOR"TAB(39)V(L):GOTO 4460
4530  PRINT N1(L)"-"N2(L)TAB(27)"CURRENT"TAB(39)V(L)TAB(53)G(L):GOTO 4460
4540  PRINT N1(L);"-";N2(L);TAB(27);"VOLTAGE";TAB(39);V(L);TAB(53);G(L)
4550  GOTO 4460
4560  PRINT"B="N1(L)"E="N2(L)"C="V(L)TAB(27)"NPN TRANS."TAB(39)" BETA="G(L):GOTO 4460
4570  PRINT"B="N1(L)"E="N2(L)"C="V(L)TAB(27)"PNP TRANS."TAB(39)" BETA="G(L):GOTO 4460
4580  PRINT "O="N1(L)"-="N2(L)"+="V(L)TAB(27)"OP AMP"TAB(39)" GAIN="G(L):GOTO 4460
4590  PRINT"G="N1(L)"S="N2(L)"D="V(L)TAB(27)"FET TRANS."TAB(39)" GM="G(L): GOTO 4460
4600  PRINT"G="N1(L)"C="N2(L)"P="V(L)TAB(27)"CVS (TUBE)"TAB(39)" V. GAIN="G(L): GOTO 4460
4610  REM **************** CURRENT CALC *******************
4620  PRINT:PRINT;TAB(10);"Working...":PRINT:ND=0:GOSUB 3910:GOSUB 3080:GOSUB 2880
4630  ND=LS: FOR LQ=1 TO CT: IF T(LQ)=5 THEN ND=ND+1: GOSUB 2940
4640  NEXT LQ
4650  PRINT: INPUT "WANT HARD COPY (Y/N)"; Q$: IF Q$="Y" THEN GOSUB 6460 ELSE RETURN
4660  ND=LS: FOR LQ=1 TO CT: IF T(LQ)=5 THEN ND=ND+1: GOSUB 6510
4670  NEXT LQ: RETURN
4680  REM ********************* BRANCH V & I CALC **********
4690  PRINT:PRINT "ENTER A COMPONENT NUMBER FROM 0-"CT" ONLY TWO NODE ELEMENTS WILL BE CALCULATED.": ND=0: D=0
4700  PRINT "ENTRY OF '0' WILL PROVIDE A SOLUTION FOR ALL VALID BRANCHS."
4710  PRINT: PRINT" COMPONENT? (0-"CT")  ";: INPUT LB: CC=1: PRINT
4720  IF LB>CT THEN PRINT "THE HIGHEST ELEMENT NUMBER IS "CT: GOTO 4710
4730  IF LB<0 THEN 4690
4740  PRINT:PRINT;TAB(10);"Working...":GOSUB 3910:GOSUB 3080
4750  IF D=0 THEN PRINT: PRINT "COMP #" TAB(11) "REAL" TAB(21) "IMAGINARY" TAB(33) "MAGNITUDE" R$ TAB(45) "PHASE ANGLE"
4760  IF D=2 THEN LPRINT: LPRINT "COMP #" TAB(11) "REAL" TAB(21) "IMAGINARY" TAB(33) "MAGNITUDE" R$ TAB(45) "PHASE ANGLE"
4770  IF D=0 THEN PRINT: PRINT "BRANCH VOLTAGE(S):"
4780  IF D=2 THEN LPRINT: LPRINT "BRANCH VOLTAGE(S):"
4790  IF LB>0 THEN LT=LB: GOTO 4810
4800  FOR LT=1 TO CT: CC=CC+1
4810  IF T(LT)>5 THEN 4890 ELSE YB=Y(N1(LT),0)-Y(N2(LT),0):XB=X(N1(LT),0)-X(N2(LT),0)
4820  IF N2(LT)=0 THEN YB=Y(N1(LT),0): XB=X(N1(LT),0)
4830  IF N1(LT)=0 THEN YB=-Y(N2(LT),0): XB=-X(N2(LT),0)
4840  MG=SQR(YB^2+XB^2): IF RF>0 THEN MG=20*LOG(MG/RF+0)/LOG(10)
4850  IF YB=0 THEN PA=90*SGN(XB) ELSE IF YB>0 THEN PA=1/P6*ATN(XB/YB) ELSE PA=1/P6*ATN(XB/YB)+180
4860  IF D=0 THEN PRINT LT TAB(9);: PRINT USING "##.##^^^^   ";YB;XB;MG;: PRINT USING "####.#";PA
4870  IF D=2 THEN LPRINT LT TAB(9);: LPRINT USING "##.##^^^^   ";YB;XB;MG;: LPRINT USING "####.#";PA
4880  IF D=0 AND CC/20=INT(CC/20) THEN PRINT: INPUT"PRESS <CR> TO CONTINUE";FR: PRINT
4890  IF LB<>0 THEN 4910
4900  NEXT LT
4910  IF D=0 THEN PRINT "BRANCH CURRENT(S): (EXCLUDING SOURCES - USE 'I' COMMAND FOR SOURCES)
4920  IF D=2 THEN LPRINT "BRANCH CURRENT(S):
4930  IF LB>0 THEN 4950
4940  FOR LT=1 TO CT: CC=CC+1
4950  IF T(LT)>3 THEN 5060 ELSE YB=Y(N1(LT),0)-Y(N2(LT),0):XB=X(N1(LT),0)-X(N2(LT),0)
4960  IF N2(LT)=0 THEN YB=Y(N1(LT),0): XB=X(N1(LT),0)
4970  IF N1(LT)=0 THEN YB=-Y(N2(LT),0): XB=-X(N2(LT),0)
4980  IF T(LT)=1 THEN YB=YB/V(LT): XB=XB/V(LT)
4990  IF T(LT)=2 THEN TB=YB: IF W=0 THEN YB=XB*1E+10: XB=-TB*1E+10 ELSE YB=XB/(W*V(LT)): XB=-TB/(W*V(LT))
5000  IF T(LT)=3 THEN TB=YB: YB=-XB*W*V(LT): XB=TB*W*V(LT)
5010  MG=SQR(YB^2+XB^2): IF RF>0 THEN MG=20*LOG(MG/RF+0)/LOG(10)
5020  IF YB=0 THEN PA=90*SGN(XB) ELSE IF YB>0 THEN PA=1/P6*ATN(XB/YB) ELSE PA=1/P6*ATN(XB/YB)+180
5030  IF D=0 THEN PRINT LT TAB(9);: PRINT USING "##.##^^^^   ";YB;XB;MG;: PRINT USING "####.#";PA
5040  IF D=2 THEN LPRINT LT TAB(9);: LPRINT USING "##.##^^^^   ";YB;XB;MG;: LPRINT USING "####.#";PA
5050  IF D=0 AND CC/20=INT(CC/20) THEN PRINT: INPUT"PRESS <CR> TO CONTINUE";FR: PRINT
5060  IF LB<>0 THEN 5080
5070  NEXT LT
5080  IF D=0 THEN PRINT: INPUT "WANT HARD COPY (Y/N)"; Q$: IF Q$="Y" THEN D=2: GOTO 4750
5090  D=0: RETURN
5100  REM ********************* PLOT ROUTEEN ************
5110  PRINT: IF LX=3 THEN PRINT"LOG FREQUENCY PLOT"; ELSE PRINT W$" PLOT";
5120  PRINT TAB(35) F$: PRINT: LF=LL-18: SN=0: SH=0: FOR I=1 TO M
5130  IF V$="V" THEN MG=SQR(FY(I)^2+FR(I)^2): IF RF>0 THEN MG=20*LOG(MG/RF+0)/LOG(10): GOTO 5150 ELSE 5150
5140  IF FY(I)=0 THEN K=SGN(FR(I))*90 ELSE IF FY(I)>0 THEN K=1/P6*ATN(FR(I)/FY(I)) ELSE K=1/P6*ATN(FR(I)/FY(I))+180
5150  IF V$="V" THEN FP(I)=MG ELSE FP(I)=K
5160  IF FP(I)>SH THEN SH=FP(I)
5170  IF FP(I)<SN THEN SN=FP(I)
5180  NEXT I
5190  IF SN>0 THEN SN=0 ELSE SN=-SN
5200  IF SH<0 THEN SH=0
5210  SF=SH+SN: ZV=INT(LF*SN/SF+11)
5220  PRINT F1$ TAB(LF/2+7) NA$
5230  I1=INT(LF/2): I2=INT(LF*SH/(2*SF)): I3=INT(LF*SN/(2*SF)): IQ=INT(LF/4): IH=INT(3*LF/4)
5240  IF SH=0 THEN PRINT TAB(10) -SN TAB(IQ+10) -3*SN/4 TAB(I1+10) -SN/2 TAB(IH+10) -SN/4 TAB(LF+10) SH: GOTO 5290
5250  IF SN=0 THEN PRINT TAB(10) SN TAB(IQ+10) SH/4 TAB(I1+10) SH/2 TAB(IH+10) 3*SH/4 TAB(LF+10) SH: GOTO 5290
5260  IF ZV<(LF/4+11) THEN PRINT TAB(10) -SN TAB(ZV) "0" TAB(ZV+I2-1) SH/2 TAB(LF+10) SH: GOTO 5290
5270  IF ZV>(3*LF/4+11) THEN PRINT TAB(10) -SN TAB(I3+10) -SN/2 TAB(ZV) "0" TAB(LF+10) SH: GOTO 5290
5280  PRINT TAB(10) -SN TAB(I3+10) -SN/2 TAB(ZV) "0" TAB(ZV+I2-1) SH/2 TAB(LF+10) SH
5290  PRINT STRING$(11,45) "+";
5300  IF SN=0 OR SH=0 THEN PRINT STRING$(IQ-1,45) "+" STRING$(I1-IQ-1,45) "+" STRING$(IH-I1-1,45) "+" STRING$(LF-IH-1,45) "+": GOTO 5340
5310  IF ZV<(LF/4+11) THEN PRINT STRING$(ZV-11,45) "+" STRING$(I2-1,45) "+" STRING$(LF-ZV-I2+10,45) "+": GOTO 5340
5320  IF ZV>(3*LF/4+11) THEN PRINT STRING$(I3-1,45) "+" STRING$(ZV-I3-12,45) "+" STRING$(LF-ZV+10,45) "+": GOTO 5340
5330  PRINT STRING$(I3-1,45) "+" STRING$(ZV-I3-12,45) "+" STRING$(I2-1,45) "+" STRING$(LF-ZV-I2+10,45) "+"
5340  CN=0: FOR I=1 TO M:VN=INT(LF*(SN+FP(I))/SF+11):PRINT USING "####.##"; FF(I);
5350  IF VN>11 THEN PRINT TAB(11);CHR$(186);
5360  IF VN=ZV THEN PRINT TAB(ZV)"*": GOTO 5390
5370  IF VN>ZV AND ZV>11 THEN PRINT TAB(ZV)"."TAB(VN)"*": GOTO 5390
5380  IF VN>ZV THEN PRINT TAB(VN)"*" ELSE PRINT TAB(VN)"*"TAB(ZV)"."
5390  IF CN<>0 AND CN/20=INT(CN/20) THEN INPUT"PRESS <CR> TO CONTINUE"; A$
5400  CN=CN+1
5410  NEXT I: PRINT: INPUT "WANT HARD COPY (Y/N)"; Q$: IF Q$="Y" THEN LL=74: GOSUB 6600
5420  IF V$="V" THEN PRINT:INPUT"WANT TO PLOT PHASE ANGLE (Y/N)";P$:IF P$="Y" THEN NA$="ANGLE ":V$="P":LL=XX:GOTO 5110
5430  IF V$="P" AND P$<>"Y" THEN PRINT: INPUT "WANT TO PLOT VOLTAGE (Y/N)";Q$ ELSE RETURN
5440  IF Q$<>"Y" THEN RETURN ELSE V$="V": LL=XX: IF RF>0 THEN NA$="VOLTAGE RATIO IN dB": GOTO 5110 ELSE NA$="VOLTAGE": GOTO 5110
5450  REM ********************* HARD COPY TEXT ***********************
5460  LPRINT: LPRINT "TCAP IS A PROGRAM FOR THE ANALYSIS OF ELECTRICAL CIRCUITS CONSISTING"
5470  LPRINT "OF RESISTORS, CAPACITORS, INDUCTORS AND SEVERAL COMMON ACTIVE DEVICES.
5480  LPRINT "FIRST DRAW THE CIRCUIT TO BE ANALAYZED ON A SHEET OF PAPER. ASSIGN A
5490  LPRINT "NUMBER TO EACH ELEMENT OF THE CIRCUIT. THIS IS THE COMPONENT NUMBER.
5500  LPRINT "NEXT ASSIGN A NUMBER TO EACH NETWORK NODE. A NODE IS PRESENT AT THE
5510  LPRINT "CONNECTION BETWEEN ELEMENTS. NO TWO ELEMENTS MAY BE CONNECTED WITHOUT
5520  LPRINT "A NODE BETWEEN THEM. EVERY ELEMENT MUST BEGIN AND END AT A NODE. ANY
5530  LPRINT "NUMBER OF ELEMENTS MAY BE CONNECTED TO A COMMON NODE.": LPRINT:
5540  LPRINT "ONCE ALL THE ELEMENTS AND NODES ARE NUMBERED, YOU ARE READY TO ENTER
5550  LPRINT "YOUR NETWORK INTO TCAP.": LPRINT
5560  LPRINT "TCAP WILL FIRST ASK WHETHER YOU WISH TO READ A FILE. TCAP ALLOWS YOU
5570  LPRINT "TO SAVE ON DISK CIRCUIT FILES ('S') YOU HAVE PREVIOUSLY WORKED ON. IF
5580  LPRINT "YOU DO NOT HAVE A PREVIOUS FILE YOU WISH TO WORK ON, TYPE 'N' OR
5590  LPRINT "HIT CARRIAGE RETURN AND TCAP WILL PUT YOU IN THE NEW FILE MODE. IN
5600  LPRINT "THE NEW FILE MODE, TCAP WILL FIRST ASK FOR THE HIGHEST NODE NUMBER."
5610  LPRINT "NEXT TCAP WILL ASK FOR THE NUMBER OF VOLTAGE SOURCES. IT WILL THEN
5620  LPRINT "ASK FOR THE NUMBER OF COMPONENTS. THIS NUMBER INCLUDES THE VOLTAGE
5630  LPRINT "SOURCES. YOU ARE THEN READY TO ENTER THE CIRCUIT ELEMENTS. THEY MAY
5640  LPRINT "BE ENTERED IN ANY ORDER. ENTER NODE AND ELEMENT VALUES SEPARATED BY
5650  LPRINT "COMMAS AS DIRECTED BY TCAP. FOR EXAMPLE A RESISTOR (COMPONENT TYPE #1)
5660  LPRINT "BETWEEN NODES 2 AND 3 OF 120 OHMS WOULD BE ENTERED AS '2,3,120'.": LPRINT
5670  LPRINT "TCAP INITIALLY ASSUMES CALCULATIONS ARE TO BE AT DC (0 Hz). FOR CALCULATIONS
5680  LPRINT "AT OTHER FREQUENCIES, THE FREQUENCY MUST BE SET WITH THE 'F' COMMAND.
5690  LPRINT "TCAP CAN PERFORM NODE VOLTAGE CALCULATIONS AT A SINGLE FREQUENCY OR OVER
5700  LPRINT "A RANGE OF FREQUENCIES (SWEEP). WHEN PERFORMING A NON-SWEEP CALCULATION,
5710  LPRINT "IT WILL ALWAYS RETURN TO THE LAST SINGLE FREQUENCY SPECIFIED. TCAP CAN
5720  LPRINT "ALSO CALCULATE OVER A 'SWEEP' OF COMPONENT VALUES WITH THE 'C' FUNCTION.
5730  LPRINT "AFTER A COMPONENT SWEEP CALCULATION, TCAP WILL RETURN TO THE ORIGINAL
5740  LPRINT "COMPONENT VALUE. TCAP ALWAYS TABULATES THE RESULTS OF A SWEEP CALCULATION,
5750  LPRINT "BUT IT CAN ALSO DISPLAY THESE RESULTS IN GRAPHICAL FORM.
5760  LPRINT: LPRINT "TCAP CALCULATES NODE VOLTAGES WITH THE 'V' FUNCTION. THE 'I' FUNCTION
5770  LPRINT "CALCULATES THE CURRENT SUPPLIED BY ALL NETWORK VOLTAGE AND CURRENT SOURCES,
5780  LPRINT "BUT DOES NOT CALCULATE THE CURRENT THROUGH INDIVIDUAL NETWORK ELEMENTS.
5790  LPRINT "TO DETERMINE THE VOLTAGE ACROSS AND THE CURRENT THROUGH AN ELEMENT
5800  LPRINT "(OR NETWORK BRANCH), THE 'B' COMMAND IS USED. THIS FUNCTION WILL PROVIDE
5810  LPRINT "THE VOLTAGES ACROSS ALL 2-TERMINAL NETWORK ELEMENTS AND THE CURRENTS
5820  LPRINT "THROUGH THESE ELEMENTS (EXCEPT FOR SOURCES - PROVIDED BY THE 'I' COMMAND).
5830  LPRINT "VOLTAGE IS DEFINED AS POSITIVE AT THE FIRST NODE RELATIVE TO THE SECOND
5840  LPRINT "NODE. THE 'Z' FUNCTION PROVIDES THE IMPEDANCE BETWEEN A SPECIFIED NODE AND
5850  LPRINT "GROUND (NODE 0) WITH ALL VOLTAGE SOURCES SHORTED AND ALL CURRENT SOURCES
5860  LPRINT "OPEN CIRCUITED. TO CALCULATE THE INPUT (OR OUTPUT) IMPEDANCE OF A
5870  LPRINT "NETWORK, DRIVE THE NETWORK WITH A 1 AMP CURRENT SOURCE. THE VOLTAGE
5880  LPRINT "AT THE NODE OF THE CURRENT SOURCE EQUALS THE DESIRED IMPEDANCE. THIS
5890  LPRINT "IMPEDANCE MAY BE PLOTTED USING THE 'F' COMMAND AND SWEEP FUNCTION.": LPRINT
5900  LPRINT "ANY NUMBER OF COMPONENTS (EXCLUDING VOLTAGE SOURCES) MAY BE ADDED TO
5910  LPRINT "A NETWORK WITH THE 'A' FUNCTION JUST AS LONG AS NO ADDITIONAL NODES
5920  LPRINT "ARE ADDED. 'R' AND 'D' ALLOW THE SUBSTITUTION AND DELETION OF COMPONENTS.": LPRINT
5930  LPRINT "THE 'M' FUNCTION CAUSES TCAP TO DISPLAY THE MAGNITUDES OF VOLTAGES IN
5940  LPRINT "dB. A REFERENCE VOLTAGE MUST BE SUPPLIED FOR THE 20 LOG(V/VREF) CALC.
5950  LPRINT "THE M FUNCTION IS TURNED OFF BY ENTERING A VREF=0.
5960  LPRINT CHR$(12): LPRINT "TCAP HAS 5 ACTIVE DEVICE MODELS: PNP, NPN AND FET TRANSISTORS, A
5970  LPRINT "CONTROLLED VOLTAGE SOURCE (WHICH CAN BE MADE TO ACT LIKE A TUBE) AND
5980  LPRINT "AN OPERATIONAL AMPLIFIER. FOR AC PROBLEMS THE PNP AND NPN MODELS ARE
5990  LPRINT "IDENTICAL AND CONSIST OF A .1 OHM RESISTANCE (SHORT) CONNECTED
6000  LPRINT "BETWEEN THE BASE AND EMITTER TERMINALS AND A CONTROLLED CURRENT
6010  LPRINT "SOURCE BETWEEN THE COLLECTOR AND EMITTER TERMINALS. THE CURRENT
6020  LPRINT "PRODUCED BY THIS CURRENT SOURCE IS THE PRODUCT OF THE CURRENT 
6030  LPRINT "FLOWING INTO THE BASE TERMINAL TIMES BETA. MORE COMPLEX TRANSISTOR
6040  LPRINT "MODELS MAY BE CREATED BY ADDING EXTRA ELEMENTS IN SERIES AND PARALLEL
6050  LPRINT "WITH THE DEVICE TERMINALS. FOR EXAMPLE A RESISTOR CAN BE PUT IN SERIES
6060  LPRINT "WITH THE BASE TERMINAL TO SIMULATE THE EFFECT OF Rie, OR IN PARALLEL
6070  LPRINT "WITH THE COLLECTOR/EMITTER TERMINALS TO SIMULATE THE EFFECT OF Hoe.
6080  LPRINT "ACTIVE DEVICES CAN ALSO BE COMBINED TO MAKE EVEN MORE COMPLEX MODELS.
6090  LPRINT: LPRINT "IN THE DC CASE (F=0), A .7 VOLT SOURCE IS ADDED IN SERIES WITH THE
6100  LPRINT "BASE TERMINALS OF THE BIPOLAR TRANSISTOR MODELS, WITH THE APPROPRIATE
6110  LPRINT "POLARITY FOR EITHER PNP OR NPN DEVICES, AND TCAP CHECKS FOR CORRECT
6120  LPRINT "BIAS POLARITY. IN THE AC CASE (F>0), THE .7 VOLT BATTERY IS ELIMINATED
6130  LPRINT "AND ALL CIRCUIT VOLTAGE SOURCES ARE SET TO THE FREQUENCY SPECIFIED BY
6140  LPRINT "'F', I.E., SEPARATE CIRCUITS ARE NEEDED FOR BIAS (DC) AND AC CONDITIONS.
6150  LPRINT: LPRINT "THE OPERATIONAL AMPLIFIER IS A CONTROLLED VOLTAGE SOURCE WHOSE
6160  LPRINT "OUTPUT VOLTAGE IS THE PRODUCT OF THE VOLTAGE BETWEEN ITS (+) AND
6170  LPRINT "(-) TERMINALS TIMES GAIN. AN OPEN CIRCUIT (2 MEGOHMS) IS PRESENT BE-
6180  LPRINT "TWEEN THE (+) AND (-) TERMINALS WHICH ARE FLOATING RELATIVE TO THE
6190  LPRINT "OUTPUT. THE OUTPUT VOLTAGE SOURCE HAS EFFECTIVELY A ZERO IMPEDANCE AND
6200  LPRINT "IS CONNECTED TO GROUND (NODE 0). THE FET MODEL IS A CONTROLLED CURRENT
6210  LPRINT "SOURCE, WHOSE OUTPUT DEPENDS ON THE VOLTAGE AT THE GATE TERMINAL TIMES MU.
6220  LPRINT "IT HAS BOTH INFINITE INPUT AND OUTPUT IMPEDANCES. BOTH INPUT AND OUTPUT
6230  LPRINT "TERMINALS ARE REFERENCED TO THE SOURCE NODE. DC WISE, THE FET MODEL
6240  LPRINT "CAN BE CONSIDERED AN ENHANCEMENT TYPE FET, BUT NO CHECK IS MADE FOR 
6250  LPRINT "CORRECT (LINEAR) BIAS CONDITIONS. THE CVS (CONTROLLED VOLTAGE SOURCE)
6260  LPRINT "IS SIMILAR TO THE OP-AMP, BUT HAS BOTH INPUT AND OUTPUT VOLTAGE
6270  LPRINT "REFERENCED TO ITS COMMON CATHODE NODE. IT HAS INFINITE INPUT
6280  LPRINT "AND ZERO OUTPUT IMPEDANCES. TO MAKE THE CVS MODEL A VACUUM TUBE, A
6290  LPRINT "LARGE RESISTOR SHOULD BE ADDED IN SERIES WITH THE PLATE NODE.
6300  LPRINT: LPRINT "OPTIONS:"
6310  LPRINT TAB(10), "A - ADD CIRCUIT COMPONTENT"
6320  LPRINT TAB(10), "B - CALCULATE BRANCH VOLTAGES AND CURRENTS"
6330  LPRINT TAB(10), "C - CHANGE AND SWEEP COMPONENT VALUE"
6340  LPRINT TAB(10), "D - DELETE CIRCUIT COMPONENT"
6350  LPRINT TAB(10), "F - SET OR SWEEP FREQUENCY"
6360  LPRINT TAB(10), "I - CALCULATE SOURCE CURRENTS"
6370  LPRINT TAB(10), "L - LIST PRESENT COMPONENTS"
6380  LPRINT TAB(10), "M - VOLTAGE MAGNITUDE IN dB"
6390  LPRINT TAB(10), "N - NEW CIRCUIT"
6400  LPRINT TAB(10), "R - REPLACE CIRCUIT COMPONENT": RETURN
6410  LPRINT TAB(10), "S - SAVE CIRCUIT FILE"
6420  LPRINT TAB(10), "V - CALCULATE NODE VOLTAGES"
6430  LPRINT TAB(10), "Z - CALCULATE NODE IMPEDANCE"
6440  LPRINT TAB(10), "END - END SESSION": RETURN
6450  REM *************************** HARD COPY NV, Z & I ************
6460  LPRINT: IF C$="I" THEN LPRINT F$,"CURRENT" ELSE IF C$="Z" THEN LPRINT F$, "IMPEDANCE" ELSE LPRINT F$, "VOLTAGE"
6470  LPRINT"FREQUENCY="W/P2: LPRINT
6480  LPRINT"NODE"TAB(11)"REAL"TAB(21)"IMAGINARY"TAB(33)"MAGNITUDE"R$TAB(44)"PHASE ANGLE"
6490  IF C$="I" THEN RETURN
6500  IF ND=0 THEN 6520
6510  L=ND: GOTO 6530
6520  FOR L=1 TO LS
6530  MG=SQR(Y(L,0)^2+X(L,0)^2): IF RF>0 THEN MG=20*LOG(MG/RF+0)/LOG(10)
6540  IF Y(L,0)=0 THEN PA=90*SGN(X(L,0)) ELSE IF Y(L,0)>0 THEN PA=1/P6*ATN(X(L,0)/Y(L,0)) ELSE PA=1/P6*ATN(X(L,0)/Y(L,0))+180
6550  IF C$="I" THEN LPRINT N1(LQ)"-"N2(LQ);:GOTO 6570
6560  LPRINT L TAB(9);
6570  LPRINT USING "##.##^^^^   "; Y(L,0); X(L,0); MG;: LPRINT USING " ####.#"; PA
6580  IF ND<>0 THEN RETURN
6590  NEXT L: RETURN
6600  REM ************************ HARD COPY COMPONENT LIST ************
6610  LPRINT:LPRINT F$,"FREQUENCY="W/P2:LPRINT
6620  LPRINT"BRANCH"TAB(12)"NODE":LPRINT" # "TAB(10)"CONNECTION"TAB(27)"TYPE"TAB(39)"VALUE"TAB(53)"PHASE ANGLE"
6630  FOR L=1 TO CT:LPRINT L;TAB(7);
6640  ON T(L) GOTO 6660,6670,6680,6690,6700,6720,6730,6740,6750,6760
6650  NEXT L: RETURN
6660  PRINT N1(L)"-"N2(L)TAB(27)"RESISTOR"TAB(39)V(L):GOTO 6650
6670  PRINT N1(L)"-"N2(L)TAB(27)"INDUCTOR"TAB(39)V(L):GOTO 6650
6680  PRINT N1(L)"-"N2(L)TAB(27)"CAPACITOR"TAB(39)V(L):GOTO 6650
6690  PRINT N1(L)"-"N2(L)TAB(27)"CURRENT"TAB(39)V(L)TAB(53)G(L):GOTO 6650
6700  PRINT N1(L);"-";N2(L);TAB(27);"VOLTAGE";TAB(39);V(L);TAB(53);G(L)
6710  GOTO 6650
6720  PRINT"B="N1(L)"E="N2(L)"C="V(L)TAB(27)"NPN TRANS."TAB(39)" BETA="G(L):GOTO 6650
6730  PRINT"B="N1(L)"E="N2(L)"C="V(L)TAB(27)"PNP TRANS."TAB(39)" BETA="G(L):GOTO 6650
6740  PRINT "O="N1(L)"-="N2(L)"+="V(L)TAB(27)"OP AMP"TAB(39)" GAIN="G(L):GOTO 6650
6750  PRINT"G="N1(L)"S="N2(L)"D="V(L)TAB(27)"FET TRANS."TAB(39)" GM="G(L): GOTO 6650
6760  PRINT"G="N1(L)"C="N2(L)"P="V(L)TAB(27)"CVS (TUBE)"TAB(39)" V. GAIN="G(L): GOTO 6650
6770  DATA 8,6,1
6780  DATA 5,0,1,10,0
6790  DATA 1,1,2,4,0
6800  DATA 2,2,3,.00125,0
6810  DATA 3,3,0,.0000001,0
6820  DATA 2,3,4,.00125,0
6830  DATA 1,4,5,4,0
6840  DATA 1,5,6,158,0
6850  DATA 3,6,0,.000568,0
