10  CLS: PRINT "PROGRAM FOR CALCULATING RECTANGULAR WAVEGUIDE"
20  PRINT "CHARATERISTICS AND WAVEGUIDE DIMENSIONS FOR"
30  PRINT "DIFFERENT MODES - V1.3 (2/3/1987)"
40  PRINT "      *********************************************
50  PRINT "      *                                           *
60  PRINT "      *  BY STUDENTS OF / DR. ALLEN KATZ          *
70  PRINT "      *  DEPT ELECTRONICS ENGINEERING TECHNOLOGY  *
80  PRINT "      *  TRENTON STATE COLLEGE, CN550             *
90  PRINT "      *  TRENTON, NEW JERSEY 8625                 *
100  PRINT "      *                                           *
110  PRINT "      *  THE AUTHOR RESERVES RIGHTS TO THIS       *
120  PRINT "      *  PROGRAM; HOWEVER, COPYING AND USE FOR    *
130  PRINT "      *  EDUCATIONAL PURPOSES IS ENCOURAGED.      *
140  PRINT "      *                                           *
150  PRINT "      *  PLEASE REPORT ANY ERRORS OR PROBLEMS     *
160  PRINT "      *  WITH THIS PROGRAM TO THE AUTHOR.         *
170  PRINT "      *  TEL (609) 771 2487                       *
180  PRINT "      *                                           *
190  PRINT "      *********************************************
200  PRINT:PRINT"WANT TO CALC. GUIDE CHAR (CHR), OR DIM (DIM)";:INPUT Q$
210  INPUT "DIMENSIONS IN INCHES OR CENTIMETERS (IN/CM)"; U$
220  IF U$="IN" THEN UC=1/2.54: GOTO 240
230  IF U$<>"CM" THEN 210
240  IF Q$="DIM" THEN 460
250  PRINT: PRINT "         ---------------------------     "
260  PRINT "         |                         |
270  PRINT "         |                         | B "
280  PRINT"         |                         |  "
290  PRINT"         ---------------------------   "
300  PRINT"                     A                  "
310  PRINT: PRINT "WAVEGUIDE WIDTH A IN "; U$;: INPUT A
320  PRINT "WAVEGUIDE HEIGHT B IN "; U$;: INPUT B
330  PRINT: INPUT "TEM MODE OF OPERATION M,N"; C,D
340  W1=2/SQR((C/A)^2+(D/B)^2)
350  F1=30/W1: IF U$="IN" THEN F1=F1*UC
360  PRINT "WAVELENGTH CUTOFF =";W1; U$
370  PRINT "FREQUENCY CUTOFF =";F1; "GHZ"
380  PRINT: INPUT "WHAT FREQ. (GHZ) WOULD YOU LIKE TO OPERATE AT"; F3
385  IF F3<F1 THEN PRINT: PRINT "FREQ BELOW CUTOFF": GOTO 380
390  W2=30/F3: IF U$="IN" THEN W2=W2*UC
400  Z1=377/SQR(1-(W2/W1)^2)
410  W3=W2/SQR(1-(W2/W1)^2)
420  PRINT "GUIDE CHAR. IMPEADANCE ="; Z1; "OHMS"
430  PRINT "GUIDE WAVELENGTH =";W3; U$
440  PRINT: INPUT "DO YOU WANT A HARD COPY? (Y/N)"; Q1$
450  IF Q1$="Y" THEN 610 ELSE PRINT: INPUT "ANOTHER FREQ (Y/N)"; Q$
458  IF Q$="Y" THEN 380 ELSE END
460  PRINT: INPUT "WHAT IS CUTOFF FREQ. IN GHZ"; F2
470  W4=30/F2: IF U$="IN" THEN W4=W4*UC
480  A1=W4/2
490  B1=A1/2
500  PRINT: PRINT "FOR THE TEM 1,0 MODE,"
510  PRINT "WAVEGUIDE WIDTH ="; A1; U$
520  PRINT "WAVEGUIDE HEIGHT ="; B1; U$
530  PRINT: INPUT "WHAT FREQ. (GHZ) WOULD YOU LIKE TO OPERATE AT"; F4
540  W5=30/F4: IF U$="IN" THEN W5=W5*UC
550  Z2=377/SQR(1-(W5/W4)^2)
560  W6=W5/SQR(1-(W5/W4)^2)
570  PRINT: PRINT "GUIDE CHAR. IMPEADANCE ="; Z2 "OHMS"
580  PRINT "GUIDE WAVELENGTH ="; W6; U$
590  PRINT: INPUT "DO YOU WANT A HARD COPY? (Y/N)"; Q2$
600  IF Q2$="Y" THEN 670 ELSE END
610  LPRINT "THE CHARACTERISTICS OF THE WAVEGUIDE ARE": LPRINT,
620  LPRINT "WAVELENGTH CUTOFF ="; W1; U$
630  LPRINT "FREQUENCY CUTOFF ="; F1; "GHZ"
640  LPRINT "GUIDE CHAR. IMPEADANCE ="; Z1; "OHMS"
650  LPRINT "GUIDE WAVELENGTH ="; W3; U$: LPRINT,
660  Q1$="N": GOTO 450
670  LPRINT "THE DIMENSIONS AND CHARACTERISTICS OF THE WAVEGUIDE ARE": LPRINT,
680  LPRINT "WAVEGUIDE WIDTH ="; A1; U$
690  LPRINT "WAVEGUIDE HEIGHT ="; B1; U$
700  LPRINT "GUIDE CHAR. IMPEADANCE ="; Z2; "OHMS"
710  LPRINT "GUIDE WAVELENGTH ="; W6; U$
720  END
